#include<stdio.h>
#include<linux/in.h>
#include<netdb.h>
#include<sys/types.h>
#include<sys/socket.h>
#include"lease.h"
#include<linux/unistd.h> 
#include<errno.h>

_syscall3(int, invalidate_lease, unsigned int, file, char *, server, int, size);




main()
{
  int    sock, reply_sock, serverlen;
  struct sockaddr_in name, server;
  struct message msg;
  char data[100];


  /* open socket for receiving messages from servers. */
  if((sock = socket(AF_INET, SOCK_DGRAM,0))<0)
    {
      printf("sodad: Couldn't open socket\n");
      exit(1);
    }
  
  name.sin_family = AF_INET;
  name.sin_addr.s_addr = htonl(INADDR_ANY);
  name.sin_port = htons(SODA_CLIENT_PORT);

  if(bind(sock, (struct sockaddr*)&name, sizeof name)<0)
    {
     printf("sodad: Couldn't bind socket to port %d\n",SODA_CLIENT_PORT);
     exit(1);
    } 

  if((reply_sock = socket(AF_INET, SOCK_DGRAM,0))<0)
    {
      printf("sodad: Couldn't open reply socket\n");
      exit(1);
    }


  while(1)
    {
      serverlen = sizeof server; /* this line must be HERE! */

      if(recvfrom(sock, &msg, sizeof msg, 0, (struct sockaddr *) &server, &serverlen) < 0)
	{
	  printf("sodad: error found while reading message from server\n");
	  exit(1);
	} 

/*
      printf("Pediram para eu invalidar o lease do arquivo %d do %s\n", msg.file,
	     msg.hostname);
*/


      invalidate_lease(msg.file, msg.hostname, msg.hostnamesize); 

          
      name.sin_family = AF_INET;
      server.sin_port = htons(SODA_SERVER_PORT);


      if(sendto(reply_sock, &msg.file, sizeof msg.file, 0, (struct sockaddr *) &server, 
		 serverlen) < 0)
	{
	  printf("sodad: warning: Couldn't send reply to server\n");
	}

    }/* while (1) */
}






