/* structures.h */
#include<linux/types.h>

void init_cache_table(void);
struct list_node *new_cache_block(struct hash_table_entry *file,
				  struct list_node *predecessor);
void remove_cache_block_LRU_list(struct list_node *block);
void refresh_block_LRU_list(struct list_node *block);
void remove_cache_block_offset_list(struct list_node *block);
int remove_LRU_cache_block(void);
void clear_file_cache(struct hash_table_entry *file);
void remove_file_cache(struct hash_table_entry *file);
void delete_file_from_cache(unsigned long inode_number, char *hostname);
struct list_node *find_cache_block(struct hash_table_entry *file, off_t offset);
struct list_node *find_predecessor(struct hash_table_entry *file, off_t offset);
void *cache_malloc(unsigned int size);










	




